%First the environment is cleared
clc
close all
clear all
fclose('all');


%Input variables are predefined
%%%%Please edit this section
Num.struct = 1;%Choose the file name of the main structure 'main.xyz',; the file number: 1 - for first file by name and so on, 0 - not yet implemented recurse all as reference
Num.M = 8;%Choose the percentage multiplier for Num.low to find potentially good structures
Num.low = 1;%Choose the least percentage of eigenvalue sum difference to accept before trying to find structures with fewer atoms
Num.low2 = 80;%Choose the least score percentage to accept for output in reference to the best one found by the scoring function
Num.empi1 = 1.24;%empirical multiplier similar to the geometric unialign/TMscore aproach
Num.empi2 = 1.8;
Num.empi3 = 0;%original "15" value modified to 0
Num.rand_rot = linspace(pi/12,0,3);%Choose a number of rotation angles to rotate the aligned structures
%%%%Please edit this section


%setting extra rotations based on Num.rand_rot
Num.rand_rot = nchoosek([Num.rand_rot Num.rand_rot Num.rand_rot],3);
Num.rand_rot = unique(Num.rand_rot, 'rows', 'stable');
[Num.rand_rot2,~] = size(Num.rand_rot);
Num.Brot = [0,0,pi/2;0,pi/2,pi/2;pi/2,0,pi/2;pi,0,pi/2;0,pi,pi/2;pi/2,pi/2,pi/2;pi/2,pi,pi/2;pi,pi/2,pi/2;pi,pi,pi/2;0,0,pi;0,pi/2,pi;pi/2,0,pi;pi,0,pi;0,pi,pi;pi/2,pi/2,pi;pi/2,pi,pi;pi,pi/2,pi;0,pi/2,0;pi/2,0,0;pi,0,0;0,pi,0;pi/2,pi/2,0;pi/2,pi,0;pi,pi/2,0;pi,pi,0];%possible pi/2 good rotations
%Files are searched for in the "in" folder.
mols         = dir('in');
mols         = mols(~[mols.isdir]);
[Num.Mols,~] = size(mols);%The number of amino acids is equal to that of the found files
%Importing data from files and cartesian distance matrix generation
[mols, Num, l] = impCart(mols, Num);
%Aligning all structures and gaining all eigenvalues
for k = 1 : Num.Mols
	[mols(k).xyz, ~,~, mols(k).d_x, mols(k).d_y, mols(k).d_z, mols(k).t6] = OrigEig(mols(k).d_x, mols(k).d_y, mols(k).d_z, 0,0); %The eigenproblem algorithm is ran for the first time
	[~] = writexyz(mols(k).Id, mols(k).xyz, 'results/aligned/', mols(k).name(1:end-4), 0, 0); %Initially aligned '.xyz' files are exported in the 'results\aligned' folder
	[mols(k).allE, mols(k).remAT] = moreData(mols(k).d_x, mols(k).d_y, mols(k).d_z); %Sums of squared eigenvalues are found for all possible candidates
	end
for k = 1 : Num.Mols
	if k ~=l
		[mols(k).indexes, mols(k).xyzR] = indx(mols(k).d_x, mols(k).d_y, mols(k).d_z, mols(k).allE(:,4:5), mols(k).remAT, mols(l).d_x, mols(l).d_y, mols(l).d_z, mols(l).allE(:,4:5), mols(l).remAT, Num.low, Num.M); %Candidates with fewer atoms are aligned using the eigenproblem approach
		[mols(k).xyzR, mols(k).indexes] = align(mols, k, Num); %pi/2 rotations are added and trilateration is run
		mols(k).xyzR = trans(mols, k, l); %Structures are translated on top of the reference structure
		[mols(k).compare, mols(k).tabFin] = choice(mols, k, l, Num.empi1, Num.empi2, Num.empi3, Num.low2); %TM-score is used to compare alignements and choose the best one from candidates
		[~] = tables1(mols, k, l); %exporting some tables
		end
	end
[~] = tables2(mols, l, Num.Mols);%exporting some tables
%Some unnecesary fields are removed;
mols = rmfield(mols,'date');mols = rmfield(mols,'bytes');mols = rmfield(mols,'isdir');mols = rmfield(mols,'datenum');mols = rmfield(mols,'folder');
fclose('all');
clear i j d_x d_y d_z k l ans
	%%%%
	%%%%ALL FUNCTIONS
	%%%%
	%choose best alignements based on best TM-score
function [compare, tabFin2] = choice(mols, k, l, empi1, empi2, empi3, low)
	if size(mols(l).Id, 1) > size(mols(k).Id, 1) %find the length of the smallest amino-acid to take into account by TM-score
		smLen = max(max(mols(k).d_r));
		else
		smLen = max(max(mols(l).d_r));
		end
	for m = 1 : size(mols(k).xyzR, 2)
		compare(m).xyzCombi = vertcat(mols(l).xyz, mols(k).xyzR{m});%concatenate the two candidates
		[~,~,~, compare(m).d_r] = cartDmat(compare(m).xyzCombi);%find distances between atoms of the two candidates for TM-score to take into account
		compare(m).d_rS = compare(m).d_r(size(mols(l).xyz, 1) + 1 : size(compare(m).d_r, 1), 1 : size(mols(l).xyz, 1));%keep only distances between atoms of different structures
		[compare(m).pairs, uR, uC] = matchpairs(compare(m).d_rS, 1, 'min');%find atoms that will be superposed based on a linear assignment problem that allows for minimum-cost solutions
		compare(m).plus = min(compare(m).d_rS(uR, uC));find the leght between atoms of the next pair not choosen by matchpairs to compare to other candidates
		compare(m).plus2 = sum(min(compare(m).plus(compare(m).plus > 2))); %this value is based on an average bond length and it may be changed to double the maximum distance between atoms
		sizex(m) = size(compare(m).pairs, 1);%the number of pairs so that the sum used by TM-score can be calculated within the next “for”
		compare(m).sizex = sizex(m);
		sumz = 0;
		d0=(empi1 * sqrt(smLen - empi3) - empi2);%empirical scaling factor for distance normalization used by TM-score
		for i = 1 : sizex(m)
			compare(m).mins(i) = compare(m).d_rS(compare(m).pairs(i,1),compare(m).pairs(i,2));
			sumz = sumz + 1 / (1 + (compare(m).mins(i) / d0)^2);
			end
		compare(m).sum = 1 / compare(m).sizex * sumz;%resulted TM-score
		a(m)=compare(m).sum;
		compare(m).difminmax = max(compare(m).mins);%find maximum legth from pairs choosen by matchpairs to compare to the minimum legth from all candidates 
		end
	tabFin = [nan,nan;nan,nan];%*Tscore.xls table is prepared
	for al = 1 : size(mols(k).xyzR, 2)
		if a(al) > max(a) * low / 100
			if abs(tabFin(end, 2) - a(al)) < 0.000001
				else
				tabFin(end + 1, 1) = al;
				tabFin(end, 2) = a(al);
				[~] = writexyz(mols(k).Id, mols(k).xyzR{al}, 'results/rotated/', strcat(mols(k).name(1:end-4), '-', num2str(al)), 0, 0);% selected candidates *.xyz geometry is exported
				end
			end
		end
	tabFin(1 : 2, :) = [];
	for al = 1 : size(tabFin, 1)
		tabFin2{al, 1} = mols(k).name(1 : end - 4);
		tabFin2{al, 2} = tabFin(al, 1);
		tabFin2{al, 3} = tabFin(al, 2);
		tabFin2{al, 4} = [mols(k).Id{compare(tabFin(al, 1)).pairs(:, 1)}];
		[rr,~] = find(mols(k).indexes==mols(k).indexes(tabFin(al, 1), 2),1);
		tabFin2{al, 5} = round(mols(k).indexes(rr, 10:12), 4);
		tabFin2{al, 6} = [mols(l).Id{compare(tabFin(al, 1)).pairs(:, 2)}];
		tabFin2{al, 7} = round(mols(k).indexes(tabFin(al, 1), 3:5), 4);
        end
    end
	%translate on axes
function xyzR = trans(mols, k, l)
	for m = 1 : size(mols(k).xyzR, 2)
		a = mols(k).xyzR{m}(mols(k).remAT(mols(k).indexes(m, 1), :), :);%return only atoms for the selected pair for aligned structure
		b = mols(l).xyz(mols(l).remAT(mols(k).indexes(m, 2), :), :); %return only atoms for the selected pair for reference structure
		c(1, :) = [sum(a(:, 1)) sum(a(:, 2)) sum(a(:, 3))];%sum of the positions of atoms on each ordonate for aligned structure
		c(2, :) = [sum(b(:, 1)) sum(b(:, 2)) sum(b(:, 3))];% sum of the positions of atoms on each ordonate for reference structure
		d = c(2, :) - c(1, :);
		xyzR{m} = mols(k).xyzR{m} + d / size(a, 1);%translate the aligned structure on top of the reference
		end
	end
	%pi/2 rotations are addedalign candidate structures
function [xyzR, Aindexes] = align(mols, k, Num)
		for j = 1 : size(mols(k).xyzR, 2)
			[d_x, d_y, d_z,~] = cartDmat(mols(k).xyzR{j});%return candidate cartesian coordinate matrices
			for i = 1 : 25
				x=[];y=[];z=[];
				[mols(k).xyzR{end+1},mols(k).indexes(end, 3:5),~,x,y,z,~] = OrigEig(d_x, d_y, d_z, Num.Brot(i,:), 1);%-mols(k).indexes(:, 6:8)
				mols(k).indexes(end+1, 1)= mols(k).indexes(j, 1);%data is entered in the index containing candidates
				mols(k).indexes(end, 2) = mols(k).indexes(j, 2); %data is entered in the index containing candidates
				end
			end
		%candidates are grown to the original structure using a trilateration algorithm
		for i = 1 : size(mols(k).indexes, 1)
			indxTri = find(mols(k).remAT(mols(k).indexes(i, 1), :));
			findPoints = 0;
			for j = 1 : size(mols(k).xyz, 1)
				if indxTri(indxTri == j)
					else
					findPoints(end+1) = j;
					mols(k).xyzR{i}(j+1 : end+1, :) = mols(k).xyzR{i}(j : end, :);
					mols(k).xyzR{i}(j, :) = zeros;
					end
				end
			findPoints(1) = [];
			indxTri(5:end) = [];
			for j = 1 : size(findPoints, 2)
				P = mols(k).xyzR{i}(indxTri, :)';
				S = mols(k).d_r(findPoints(j), indxTri);
				W = diag(ones(1, 4));
				[N1 N2] = Trilateration(P,S,W);
				mols(k).xyzR{i}(findPoints(j), :) = N1(2 : end);
				end
			
			end
			Aindexes = mols(k).indexes;
			xyzR = mols(k).xyzR;%aligned candidate with fewer atoms is overwritten by the full amino-acid grown by trilateration
	end
	%Eigenvalue sums are compared for structures of same number of atoms, based on 'Num.low' and 'Num.M' input variablesfind eig differences between potential similar structures and get data for results
function [indexes, xyzR] = indx(x, y, z, e, remAT, x0, y0, z0, e0, remAT0, low, mult);
	%mult = mult ^ 3;
	r1 = size(e, 1);%find the number of possible candidates for aligned amino acid
	r0 = size(e0,1);%find the number of possible candidates for reference amino acid
	for i = 1 : r1
		for j = 1 : r0
			if e(i, 1) == e0(j, 1)%if the number of atoms of candidates match, find the percent difference of sums of eigenvalues
				eI(i, j) = e(i, 1);%number of atoms matched
				eT(i, j) = abs((e(i, 2) - e0(j, 2)) / e0(j, 2) * 100);%percent of difference between sums of eigenvalues
				end
			end
		end
	indexes = levelsDeep(eT, eI, low, mult);%find candidates by comparing to given input variables num.low and num.mult
	[NRgood] = size(indexes, 1);
	for i = 1 : NRgood
		indexes(i, 9) = e(indexes(i, 1), 2); %data is entered in the index containing candidates
		xi = x(remAT(indexes(i, 1), :), remAT(indexes(i, 1), :));%Cartesian coordinates are stripped of unmatched atoms for aligned amino-acid
		yi = y(remAT(indexes(i, 1), :), remAT(indexes(i, 1), :));
		zi = z(remAT(indexes(i, 1), :), remAT(indexes(i, 1), :));
		[xyzRem, e1, rot1,~,~,~,~] = OrigEig(xi, yi, zi, 0, 0);%the eigenproblem is used to align candidates with fewer atoms
		indexes(i, 3:5) = e1; %data is entered in the index containing candidates
		indexes(i, 6:8) = rot1; %data is entered in the index containing candidates
		xyzR{i} = xyzRem;%structure stripped of unaligned atoms
		end
	for i = 1 : NRgood
		indexes(i, 16) = e0(indexes(i, 2), 2);% data is entered in the index containing candidates
		xi = x0(remAT0(indexes(i, 2), :), remAT0(indexes(i, 2), :)); %Cartesian coordinates are stripped of unmatched atoms for reference amino-acid
		yi = y0(remAT0(indexes(i, 2), :), remAT0(indexes(i, 2), :));
		zi = z0(remAT0(indexes(i, 2), :), remAT0(indexes(i, 2), :));
		[~, e2, rot2,~,~,~,~] = OrigEig(xi, yi, zi, 0, 0); %the eigenproblem is used to align candidates with fewer atoms
		indexes(i, 10:12) = e2; % data is entered in the index containing candidates
		indexes(i, 13:15) = rot2; % data is entered in the index containing candidates
		end
	end
	%penetrate structure untill Num.low is reached / find candidates by comparing to given input variables num.low and num.mult
function indexes = levelsDeep(eT, eI, low, mult)
	sizeM = max(eI(:));%the search starts from the maximum number of matching pairs of atoms
	e2 = eT;%a backup is made
	e2(eI < sizeM) = 0;%all other lower number of matching pairs is neglected for now
	low2 = min(e2(e2 > 0));%the lowest percent of difference in the case of maximum number of pairs is found
	if low2 < low%If this percent is better than the input variable, the search stops and more close scores are taken into account
		low2 = low2 * mult;% more close scores are taken into account as per the input variable num.mult
		[e3, e4] = find(e2 > 0 & e2 < low2);
		indexes = [e3, e4]; % data is entered in the index containing candidates
		else% if the percentage is not good enough it is saved and the serach continues with a lower number of pairs
		if size (low2, 1) == 0
			else
			[e3, e4] = find(e2 == low2); % data is entered in the index containing candidates
			eT(eI == sizeM) = 0;%the maximum pair number cases are removed
			eI(eI == sizeM) = 0; %the maximum pair number cases are removed
			indexes = [e3, e4]; % data is entered in the index containing candidates
			i2 = levelsDeep(eT, eI, low, mult);
			indexes(end+1:end+size(i2, 1), :) = i2; % data is entered in the index containing candidates
			end
		end
	end
	%All possible combinations of candidates with fewer atoms are foundfind all eig values for smaller structures
function [allE, remAT] = moreData(x, y, z)
	[allE(:, 1), remAT] = AllE(x);
	[allE(:, 2),~] = AllE(y);
	[allE(:, 3),~] = AllE(z);
	[rows] = 2^size(x, 1)-1;
	for l = 1 : rows
		allE(l, 4) = sum(remAT(l, :) ~= 0);
		allE(l, 5) = (allE(l,1) + allE(l,2) + allE(l,3));
		allE(l, 6) = allE(l,5) / allE(l,4);
		end
	end
	%Eigenvalues are found for all combinationseigenvalues for each smaller matrix
function [e, S] = AllE(d)
	S=dec2bin(1:2^size(d,1)-1)=='1';
	b=cell(size(S,1),1);
	for ix=1:size(S,1)
   		b{ix}=d(find(S(ix,:)),find(S(ix,:)));
		if isempty(b{ix})<1
			e(ix,1)=s2a(eig(b{ix}));
			end
		end
	end
	%Cartesian distance matricesx isare generated;
function [d_x, d_y, d_z, d_r] = cartDmat(xyz)
    [Num.Rows,~] = size(xyz);
    for i = 1 : Num.Rows
        for j = 1 : Num.Rows
            d_x(i,j) = xyz(i,1) - xyz(j,1);
            d_y(i,j) = xyz(i,2) - xyz(j,2);
            d_z(i,j) = xyz(i,3) - xyz(j,3);
        	d_r(i,j) = sqrt(d_x(i,j)*d_x(i,j) + d_y(i,j)*d_y(i,j) + d_z(i,j)*d_z(i,j));
            end
        end
    end
	%xyz file export function
function xyz1 = writexyz(Id, xyz0, folder, name, main, i2)
    xyz1     = [Id num2cell(xyz0)];
	if i2    == 0
	    fid  = fopen(strcat(folder, name,'.xyz'),'wt');
		else
		if main == 1
			fid  = fopen(strcat(folder, name,'-', num2str(i2),'-main.xyz'),'wt');
			else
			fid  = fopen(strcat(folder, name,'-', num2str(i2),'.xyz'),'wt');
			end
    end
	[Rows,~] = size(xyz0);
    fprintf(fid,'%s\n',num2str(Rows));
    fprintf(fid,'%s\n',name);
    for l    = 1:Rows
        fprintf(fid,'%s\t%.6f\t%.6f\t%.6f\n',xyz1{l,:});
    end
    fclose(fid);
	end
	%First rotation function from the original eigenproblem algorithm;
function f = rotat_x(u,v,t)
    f = u*cos(t) - v*sin(t);
    end
    %Second rotation function from the original eigenproblem algorithm;
function f = rotat_y(u,v,t)
    f = u*sin(t) + v*cos(t);
    end
	%Coeficients transfer function from the original eigenproblem algorithm;
function f = sum_eig_rotat_x(u,v,t)
    f = -s2a(eig(rotat_x(u,v,t)));
    end
    %Sumation of coeficients function from the original eigenproblem algorithm;
function f = s2a(u)
    Num.Rows = size(u);
    f = 0;
    for i=1:Num.Rows
        f = f + u(i)*u(i);
    end
    end
	%dxyz2xyz - reverse of cartDmat
function xyz = dxyz2xyz(d3x, d3y, d3z)
	[~,Num.minCol] = find(d3x == min(d3x(:)));
    xyz0(:,1)      = d3x(:,Num.minCol);
    [~,Num.minCol] = find(d3y == min(d3y(:)));
    xyz0(:,2)      = d3y(:,Num.minCol);
    [~,Num.minCol] = find(d3z == min(d3z(:)));
    xyz0(:,3)      = d3z(:,Num.minCol);
    xyz(:,1) = xyz0(:,1)-min(xyz0(:,1))/2;
    xyz(:,2) = xyz0(:,2)-min(xyz0(:,2))/2;
    xyz(:,3) = xyz0(:,3)-min(xyz0(:,3))/2;
	end
	%The original eigenproblem algorithm, plus a way to rotate a structure, plus the selection of one translated structure;
function [xyz, e, rot, d3x, d3y, d3z, t6] = OrigEig(d_x, d_y, d_z, rot, tuv)
    %In case angles are not known they are found for alignement;
	if tuv  == 0
	    fr1 = @(t)sum_eig_rotat_x(d_x, d_y, t);
        rot(1) = fminbnd(fr1, 0, pi);
	end
	%In case angles are known the structure is rotated;
	d1x = rotat_x(d_x,d_y,rot(1));
    d1y = rotat_y(d_x,d_y,rot(1));
    d1z = d_z;
	if tuv  == 0
	    fr2 = @(u)sum_eig_rotat_x(d1x, d1z, u);
        rot(2) = fminbnd(fr2, 0, pi);
	end
    d2x = rotat_x(d1x,d1z,rot(2));
    d2y = d1y;
    d2z = rotat_y(d1x,d1z,rot(2));
	if tuv  == 0
	    fr3 = @(v)sum_eig_rotat_x(d2y, d2z, v);
        rot(3) = fminbnd(fr3, 0, pi);
	end
    d3x  = d2x;
    d3y  = rotat_x(d2y,d2z,rot(3));
    d3z  = rotat_y(d2y,d2z,rot(3));
	t6(1, :) = eig(d3x);
	t6(2, :) = eig(d3y);
	t6(3, :) = eig(d3z);
	e(1) = s2a(t6(1, :).');
	e(2) = s2a(t6(2, :).');
	e(3) = s2a(t6(3, :).');
    xyz = dxyz2xyz(d3x, d3y, d3z);
    end
	%importing data from files and cartesian distance matrix generation
function [mols, Num, l] = impCart(mols, Num)
for k = 1 : Num.Mols
    %In the case of an xyz file data is only imported;
    if strcmp(mols(k).name(end-2:end),'xyz')>0
        mols(k).initial     = fopen(strcat('in/',mols(k).name));
        mols(k).initial     = textscan(mols(k).initial,'%s','HeaderLines',2);
        mols(k).initial     = reshape(mols(k).initial{1}(1:end,:),4,[])';
        [Num.Rows,Num.Cols] = size(mols(k).initial);
        mols(k).nratomi     = Num.Rows;
        mols(k).initial(strncmp(mols(k).initial(:,1),'H',1),:)=[];
        mols(k).Id          = mols(k).initial(:,1);
        mols(k).initial     = str2double(mols(k).initial(:,2:4));
    end
	%In case of an sdf file importing starts similar to the xyz case;
    if strcmp(mols(k).name(end-2:end),'sdf')>0
        mols(k).initial = fopen(strcat('in/',mols(k).name));
        mols(k).initial = textscan(mols(k).initial,'%s');
        mols(k).orignam = mols(k).initial{1,1}(1);
        mols(k).swdetai = mols(k).initial{1,1}(2);
        mols(k).initial = fopen(strcat('in/',mols(k).name));
        mols(k).initial = textscan(mols(k).initial,'%s','HeaderLines',3);
		%A bug is avoided when the atoms number is not spaced from the bonds number;
        if strlength(mols(k).initial{1,1}(1))>3
            Num.temp    = mols(k).initial{1,1}(1);
            Num.temp    = [Num.temp{:}];
            Num.temp2   = strcmp(mols(k).initial{1,1},'END');
            [Num.temp3,Num.temp4] = find(Num.temp2>0);
            Num.temp2   = mols(k).initial{1,1}(1:Num.temp3-2);
            Num.temp2   = [Num.temp2{:}];
            Num.temp2(regexp(Num.temp2,'[abcdefghijklmnopqrstuvwxyz0123456789.-]')) = [];
            [Num.temp3,Num.temp4] = size(Num.temp2);
            mols(k).nratomi = Num.temp4-1;
			Num.temp4   = strlength(num2str(mols(k).nratomi));
			Num.temp3   = strlength(Num.temp);
			%A verification of the correct workaround for the above bug is needed;
			if Num.temp4    == Num.temp3
			    if Num.temp == num2str(mols(k).nratomi)
				    else
					debug.error1 = 1;
				end
			    else
				debug.error1 = 2;%wrong nr of atoms
			end
            else
            mols(k).nratomi = str2double(mols(k).initial{1,1}(1));
        end
        mols(k).initial    = fopen(strcat('in/',mols(k).name));
        mols(k).initial    = textscan(mols(k).initial,'%s','HeaderLines',4);
        mols(k).initial    = reshape(mols(k).initial{1}(1:16*mols(k).nratomi,:),16,[])';
        mols(k).originalId = mols(k).initial(:,4);
        mols(k).initial(strncmp(mols(k).initial(:,4),'H',1),:) = [];
        mols(k).Id         = mols(k).initial(:,4);
        mols(k).initial    = str2double(mols(k).initial(:,1:3));
		%The initial structure is exported via the writexyz function;
        [~] = writexyz(mols(k).Id, mols(k).initial(:,1:3), 'in/xyz/', mols(k).name(1:end-4), 0, 0)
        end
        %Cartesian distance matrix is generated;
		[mols(k).d_x, mols(k).d_y, mols(k).d_z, mols(k).d_r] = cartDmat(mols(k).initial); %Cartesian distance matrices are generated
		mols(k).e(1) = s2a(eig(mols(k).d_x));
		mols(k).e(2) = s2a(eig(mols(k).d_y));
		mols(k).e(3) = s2a(eig(mols(k).d_z));
	end
	%Find index of chosen reference structure
if isnumeric(Num.struct) & Num.struct > 0 & Num.struct <= Num.Mols
	l = Num.struct;
	else
	if ischar(Num.struct)
		for k = 1 : Num.Mols
			if strcmp(mols(k).name, Num.struct)
				l = k;
				end
			end
		end
	end
	end
	%Export tables for article
function x = tables1(mols, k, l)
	x = {"x (Å)", "y (Å)", "z (Å)", "Atom", "Label"};
	x(2:size(mols(k).Id, 1)+1, 1:3) = num2cell(mols(k).initial);
	x(2:size(mols(k).Id, 1)+1, 4) = mols(k).Id;
	x(2:size(mols(k).Id, 1)+1, 5) = num2cell(1:size(mols(k).Id));
	writecell(x, strcat('results/tables/', mols(k).name(1:end-4), '-T1.xls'));
	x = {"3D", "3D Distances"};
	x(1, size(mols(k).Id, 1)+2) = {"Eigenvalues"};
	x(2, 2:size(mols(k).Id, 1)+1) = num2cell(1:size(mols(k).Id));
	x(3:size(mols(k).Id, 1)+2, 1) = num2cell(1:size(mols(k).Id)).';
	x(3:size(mols(k).Id, 1)+2, 2:size(mols(k).Id, 1)+1) = num2cell(mols(k).d_r);
	writecell(x, strcat('results/tables/', mols(k).name(1:end-4), '-T2.xls'));
	x(3:size(mols(k).Id, 1)+2, 2:size(mols(k).Id, 1)+1) = num2cell(mols(k).d_x);
	writecell(x, strcat('results/tables/', mols(k).name(1:end-4), '-T3.xls'));
	x(3:size(mols(k).Id, 1)+2, 2:size(mols(k).Id, 1)+1) = num2cell(mols(k).d_y);
	writecell(x, strcat('results/tables/', mols(k).name(1:end-4), '-T4.xls'));
	x(3:size(mols(k).Id, 1)+2, 2:size(mols(k).Id, 1)+1) = num2cell(mols(k).d_z);
	writecell(x, strcat('results/tables/', mols(k).name(1:end-4), '-T5.xls'));
	x = {"", "", ""; "[Dx]", "", ""; "[Dy]", "", ""; "[Dz]", "", ""};
	y = mols(k).t6; y = imag(y); y(:, 3:end) = 0; y = round(y, 3);
	x{2, 2} = strcat(num2str(y(3, 1)), "i");x{2, 3} = strcat(num2str(y(3, 2)), "i");x{3, 2} = strcat(num2str(y(2, 1)), "i");x{3, 3} = strcat(num2str(y(2, 2)), "i");x{4, 2} = strcat(num2str(y(1, 1)), "i");x{4, 3} = strcat(num2str(y(1, 2)), "i");
	for i = 2:size(y, 2)+1
		x{1, i} = strcat("x", char(8320+i-1));
	end
	x(2:4, 4:size(y, 2)+1) = num2cell(y(:, 3:size(y, 2)));
	writecell(x, strcat('results/tables/', mols(k).name(1:end-4), '-T6.xls'));
	x = {"Matrix (A)", "|λ·I − A| Polynomial"; "[Dx]", ""; "[Dy]", ""; "[Dz]", ""};
	x{2, 2} = strcat("λ", char(8312),"∙(λ", char(178)," + ", num2str(abs(mols(k).e(1)/2)),")");x{3, 2} = strcat("λ", char(8312),"∙(λ", char(178)," + ", num2str(abs(mols(k).e(2)/2)),")");x{4, 2} = strcat("λ", char(8312),"∙(λ", char(178)," + ", num2str(abs(mols(k).e(3)/2)),")");
	writecell(x, strcat('results/tables/', mols(k).name(1:end-4), '-T7.xls'));
	end
	%export final table
function x = tables2(mols, l, Mols)
	x={"aligned structure", "index of chosen rotation", "TM-score", strcat("selected atoms from ", mols(l).name(1:end-4)), "eigenvalues of reference substructurecandidate", "selected atoms from aligned structure", "eigenvalues of aligned candidatesubstructure"};
	for k = 1 : Mols
		if k ~=l
			for i = 1 : size(mols(k).tabFin,1)
				x{end+1,1}=[mols(k).tabFin{i,1}];
				x{end,2}=num2str(mols(k).tabFin{i,2});
				x{end,3}=num2str(mols(k).tabFin{i,3});
				x{end,4}=[mols(k).tabFin{i,4}];
				x{end,5}=num2str(mols(k).tabFin{i,5});
				x{end,6}=[mols(k).tabFin{i,6}];
				x{end,7}=num2str(mols(k).tabFin{i,7});
				end
			end
		end
	writecell(x, strcat('results/tables/', mols(l).name(1:end-4), '-Tscore.xls'));
	end
	%export eigenvalue algorithm test table
function x = tables3(a, b, k, name)
	x = num2cell(b);
	x(:, end+1 : end+3) = num2cell(a);
	writecell(x, strcat('results/tables/', name(1:end-4), '-Etest.xls'));
	end